<?php
namespace EMS\PortalFuncionario\Geral\Repository;

use Zeedhi\Framework\Controller\Crud;
use Doctrine\ORM\EntityManager;

use EMS\PortalFuncionario\Util\DateUtil;

class GeralRepository {

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    public function getAniversariantes(
        int $nrOrg,
            $dtmescompetenc = null
    ): array {
        if (empty($dtmescompetenc)) {
            $dtmescompetenc = DateUtil::getPrimeiroDiaDoMes(DateUtil::getDataAtual())->format(DateUtil::FORMATO_BRASILEIRO);
        }

        $sql = <<<SQL
            SELECT 
            TO_CHAR(PEH.DTNASCPESSOA, 'DD/MM') DTANIVERSARIO,
            VM.NMVINCULOM,
            EH.NMESTRUTURAH,
            OP.DSEMAILOPER
            FROM GPE_VINCULOM VM
            JOIN GPE_VINCULOH VH ON VH.NRORG      = VM.NRORG
                                AND VH.NRVINCULOM = VM.NRVINCULOM
                                AND VH.DTMESCOMPETENC =
                                (SELECT DTMESCOMPETENC FROM 
                                    (SELECT 
                                        VH1.DTMESCOMPETENC 
                                    FROM 
                                        GPE_VINCULOH VH1 
                                    WHERE 
                                        VH1.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')  
                                        AND VH1.NRORG = VH.NRORG 
                                        AND VH1.NRVINCULOM = VH.NRVINCULOM 
                                        ORDER BY VH1.DTMESCOMPETENC DESC) 
                                WHERE ROWNUM = 1)
            /*Estrutura Gerencial*/
            JOIN ESTRUTURAM EMG ON EMG.NRORG        = VM.NRORG
                               AND EMG.NRESTRUTURAM = VH.NRESTRUTGEREN --!
            JOIN ESTRUTURAH EH ON EH.NRORG = EMG.NRORG
                                AND EH.NRESTRUTURAM = EMG.NRESTRUTURAM
                                AND EH.DTMESCOMPETENC = (
                                            (SELECT DTMESCOMPETENC FROM 
                                                (SELECT 
                                                    EH1.DTMESCOMPETENC 
                                                FROM 
                                                    ESTRUTURAH EH1 
                                                WHERE 
                                                    EH1.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY')
                                                    AND EH1.NRORG = EH.NRORG 
                                                    AND EH1.NRESTRUTURAM = EH.NRESTRUTURAM 
                                                ORDER BY EH1.DTMESCOMPETENC DESC) 
                                            WHERE ROWNUM = 1)
                                        )
            JOIN GPE_PESSOA PE ON PE.NRORG    = VM.NRORG
                              AND PE.NRPESSOA = VM.NRPESSOA
            JOIN GPE_PESSOAH PEH ON PEH.NRORG    = VM.NRORG
                                     AND PEH.NRPESSOA = PE.NRPESSOA
                                     AND PEH.DTMESCOMPETENC = ( SELECT DTMESCOMPETENC FROM 
                                                                (SELECT DTMESCOMPETENC FROM GPE_PESSOAH GHH 
                                                                 WHERE GHH.NRORG = VH.NRORG AND GHH.NRPESSOA = PE.NRPESSOA
                                                                 ORDER BY GHH.DTMESCOMPETENC DESC) 
                                                               WHERE ROWNUM = 1)
                                    AND SUBSTR(:P_DTMESCOMPETENC, 4, 2) = TO_CHAR(PEH.DTNASCPESSOA, 'MM')
                                    AND PEH.DTNASCPESSOA IS NOT NULL
            LEFT JOIN OPERADOR OP ON OP.NRORG = VM.NRORG
                                      AND OP.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
            WHERE VM.NRORG = :P_NRORG
            AND ( VM.DTRESCISAOVINC >= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY') OR VM.DTRESCISAOVINC IS NULL )
            ORDER BY DTANIVERSARIO ASC
SQL;

        $params = [
            "P_NRORG"           => $nrOrg,
            "P_DTMESCOMPETENC"  => $dtmescompetenc,
        ];

        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);

        $aniversarios = $std->fetchAll();

        return $aniversarios;
    }
}